#include <Servo.h>

//Ultrasonic sensor
int Echo = 7;
int trig = 6; 

// Motor A connections
int enLeft = 5;  
int leftForward = 10;
int leftBackward = 11;
// Motor B connections
int enRight = 3;  
int rightForward = 12;
int rightBackward = 13;

//defining pins and variables -IR sensor
int IRLeft = 4;
int IRRight = 2;
int readingL= 0;
int readingR= 0;


//servo motors
int pos1 = 9;
int pos2 = 8;

Servo servo;
Servo servo_2;

bool objectDetected = false; // flag to indicate whether an object has been detected





void setup() 
{
  //declaring pin types - IR sensor
  pinMode(IRLeft,INPUT);
  pinMode(IRRight,INPUT);

  // declaring pin types - ultrasonic sensor
  pinMode(Echo, INPUT);
  pinMode(trig, OUTPUT);
  
  //begin serial communication
  Serial.begin(9600);

  // Set all the motor control pins to outputs
  pinMode(enLeft, OUTPUT);
  pinMode(enRight, OUTPUT);
  pinMode(leftForward , OUTPUT);
  pinMode(leftBackward, OUTPUT);
  pinMode(rightBackward, OUTPUT);
  pinMode(rightForward, OUTPUT);
  
  // Servo motors 
  servo.attach(9, 500, 2500);
  servo_2.attach(8, 500, 2500);
 
}








void loop() {

  
  float Ceni;
  int pulse;
  int A = 20; // distance
  
  digitalWrite(trig, LOW);
  delayMicroseconds(10);
  digitalWrite(trig, HIGH);
  delayMicroseconds(10);
  digitalWrite(trig, LOW);

  pulse = pulseIn(Echo, HIGH);

  Ceni = pulse / 29.387 / 2;

  Serial.println(Ceni);
  delay(1);



//--------------------------------------------DETECT OBJECT
  if (Ceni <= A) {  // obstacle detected
    Serial.println("Obstacle detected");
    

    //-------------------------------------STOP
    Serial.print("stop");
    analogWrite(enLeft, 70);
    analogWrite(enRight, 70);
    digitalWrite(leftForward , LOW);
    digitalWrite(leftBackward, LOW);
    digitalWrite(rightBackward, LOW);
    digitalWrite(rightForward, LOW);


    // -----------------------------------CLOSE DISPENSER

    servo.write(200);
    //servo.detach();
    delay(1000);

    // -----------------------------------ROTATION
    int rotations = 0;
    while (rotations < 1) {  // make one 180 degree turn
      //turn 180
      Serial.print("TURN");
      analogWrite(enLeft, 150);
      analogWrite(enRight, 150);
      digitalWrite(leftForward , HIGH);
      digitalWrite(leftBackward, LOW);
      digitalWrite(rightForward, HIGH);
      digitalWrite(rightBackward, LOW);
      delay(2000);

      //-------------------------------------STOP

      Serial.print("STOP");
      analogWrite(enLeft, 0);
      analogWrite(enRight, 0);
      digitalWrite(leftForward , LOW);
      digitalWrite(leftBackward, LOW);
      digitalWrite(rightBackward, LOW);
      digitalWrite(rightForward, LOW);

      //delay(2000); // wait for the robot to stop before starting the next turn
      rotations++;

    //delay(1000); // delay after the 180-degree turn
    objectDetected = true; // set flag to true

    }
    
  

    
  //--------------------------------//NO OBJECT_ SPIRAL MOVIMENT
  } else { // spiral movement
    
    Serial.println("Spiral movement");
    delay(2000); // add a delay of 2 second before starting the spiral movement

        //Move Forward
    analogWrite(enLeft, 150);
    analogWrite(enRight, 150);
    digitalWrite(leftForward , LOW);
    digitalWrite(leftBackward, HIGH);
    digitalWrite(rightForward, HIGH);
    digitalWrite(rightBackward, LOW);
    delay(1000);  
    
    
    
    //TURN RIGHT
    analogWrite(enLeft, 100);
    analogWrite(enRight, 200);
    digitalWrite(leftForward , LOW);
    digitalWrite(leftBackward, HIGH);
    digitalWrite(rightBackward, LOW);
    digitalWrite(rightForward, HIGH);
    //servo.write(0);    //---------------------------------------------------- OPEN DISPENSER
    delay(1000);

    //TURN LEFT
    analogWrite(enLeft, 200);
    analogWrite(enRight, 100);
    digitalWrite(leftForward , LOW);
    digitalWrite(leftBackward, HIGH);
    digitalWrite(rightBackward, LOW);
    digitalWrite(rightForward, HIGH);
    delay(1000);


  
  }


// If an object has been detected and avoided, resume line following

  if (objectDetected && Ceni > A) {
    objectDetected = false; // reset flag
    lineDetection(); // resume line following
    }
 }    
//----------------------FUNCTION - LINE DETECTOR
void lineDetection() {


  while (true) {
      readingL = digitalRead(IRLeft);
      readingR = digitalRead(IRRight);
      
      Serial.print("IRLeft : ");
      Serial.println(readingL);
      Serial.print(" IRRight : ");
      Serial.println(readingR);

      
  // ---------------------------------------MOTOR SERVO 2-------------sweep the second servo from 0 to 180 degrees in steps
    for (int pos = 0; pos <= 180; pos += 1) {
      // tell servo to go to position in variable 'pos'
      servo_2.write(pos);
  //-------------- wait for 15 milliseconds for servo to reach the position
      delay(2);
    }

      
     if(readingL==1 && readingR==1){
        //IRLeft and IRRight are 1 ; both are on Black
        //Move Forward
       analogWrite(enLeft, 120);
       analogWrite(enRight, 100);
       digitalWrite(leftForward , LOW);
       digitalWrite(leftBackward, HIGH);
       digitalWrite(rightForward, HIGH);
       digitalWrite(rightBackward, LOW);
    
       
      }
        //0 means output of IR sensor is high as the sensor is on white surface 
      else if(readingL==0 && readingR==1){
        //IRLeft and IRRight are 0,1 ; IRLeft is on White 
        //turn left
        analogWrite(enLeft, 120);
        analogWrite(enRight, 80);
        digitalWrite(leftForward , LOW);
        digitalWrite(leftBackward, HIGH);
        digitalWrite(rightForward, HIGH);
        digitalWrite(rightBackward, LOW);
      }
    
      
      if(readingL==1 && readingR==0){
        //IRLeft and IRRight are 1,0 ; IRRight is on White
        //turn right
        analogWrite(enLeft, 80);
        analogWrite(enRight, 120);
        digitalWrite(leftForward , LOW);
        digitalWrite(leftBackward, HIGH);
        digitalWrite(rightForward, HIGH);
        digitalWrite(rightBackward, LOW);
      }
     
    
       else if(readingL==0 && readingR==0){
        //IRLeft and IRRight are 0,0 ; IRLeft and IRRight are on White 
        //Stop
        analogWrite(enLeft, 0);
        analogWrite(enRight, 0);
        digitalWrite(leftForward , LOW);
        digitalWrite(leftBackward, LOW);
        digitalWrite(rightBackward, LOW);
        digitalWrite(rightForward, LOW);
      
      
    }
  }
}
